import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {IncomeEquipment, IncomeEquipmentParam} from './model';

/**
 * 分页查询结算
 */
export async function pageIncomeEquipment(params: IncomeEquipmentParam) {
  const res = await request.get<ApiResult<PageResult<IncomeEquipment>>>(
    '/tower/tower-income-equipment/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listIncomeEquipment(params?: IncomeEquipmentParam) {
  const res = await request.get<ApiResult<IncomeEquipment[]>>(
    '/tower/tower-income-equipment',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getIncomeEquipment(id: number) {
  const res = await request.get<ApiResult<IncomeEquipment>>(
    '/tower/tower-income-equipment/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addIncomeEquipment(data: IncomeEquipment) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-income-equipment',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateIncomeEquipment(data: IncomeEquipment) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-income-equipment',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchIncomeEquipment(data: IncomeEquipment[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-income-equipment/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchIncomeEquipment(data: IncomeEquipment[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-income-equipment/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeIncomeEquipment(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-income-equipment/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchIncomeEquipment(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-income-equipment/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
